> For the complete documentation index, see [llms.txt](https://doc.batch.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://doc.batch.com/developer/sdk/flutter/profile-data/custom-locale.md).

# Custom region/language

Batch allows you to set a custom region or a custom language that will override the value detected by the SDK. By default, Batch collects the language and the country of your users' devices.

Setting a custom region/language is useful if:

* You don't want to use the values detected by Batch.
* Your users can choose their own language or region for localization purposes.

![Custom locale](https://38998153-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FCL8wF0y1T2vLnm3yR2MW%2Fuploads%2F3UcNQrwKoaTqZ7nS8qhm%2Fios_locale_settings_screenshot.png?alt=media\&token=1795c4ed-4385-4ab1-99b7-313d0847b2a3)

**Writing custom region/language**

Here is how to set a custom region/language:

```dart
BatchProfile.instance.newEditor()
  .setLanguage("en") // Language must be 2 chars, lowercase, ISO 639 formatted
  .setRegion("US") // Region must be 2 chars, uppercase, ISO 3166 formatted
  .save();
```

To unset the custom language/region, use `null`.

**Reading custom region/language**

Keep in mind that the data returned is only about your installation and not your Profile since it may be updated from another source.

```dart
    // Result might be 'null' if Batch isn't started or if no override has been set
    var region = await BatchUser.instance.language ?? 'none';
    var region = await BatchUser.instance.region ?? 'none';
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://doc.batch.com/developer/sdk/flutter/profile-data/custom-locale.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
